/*

Copyright 2001 VLSI Solution Oy.

This file is part of PlusV Reference Software.

PlusV Reference Software is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

PlusV Reference Software is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with PlusV Reference Software; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/
#ifndef PLUSV_FILTER_H
#define PLUSV_FILTER_H

#include "fp.h"

int ClearDecimationFilter(void);
void DecimationFilterStore(int chans, const flotari *vp);
flotari DecimationFilter(int chans, flotari *vp);

int ClearInterpolationFilter(void);
void InterpolationFilter(int chans, flotari *vp, int noLatch);

int ClearUpperHalfIntFilter(void);
void UpperHalfIntFilter(int chans, flotari *vp, int noLatch);

int ClearEightBandFilter(void);
void EightBandFilter(flotari *vp);

int ClearLpFilter(int lowBand);
flotari LpFilter(int chans, flotari *vp);

int Resample44to32(int chans, flotari *p);
int Resample48to32(int chans, flotari *p);

struct FMem *InitDelay(int chans, int n);
void FilterDelay(struct FMem *fm, flotari *f, int chans);
void FreeFilterDelay(struct FMem *d);

#endif
