/*

Copyright 1995-2001 Henrik Herranen.

This file is part of PlusV Reference Software.

PlusV Reference Software is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

PlusV Reference Software is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with PlusV Reference Software; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/
#ifndef LEO_ENDIAN_H
#define LEO_ENDIAN_H

#include "leo_types.h"

/* FUNCTIONS */
lbool BigEndian(void);

u_int32 U32toBE(u_int32);
s_int32 S32toBE(s_int32);
u_int16 U16toBE(u_int16 n);
s_int16 S16toBE(s_int16 n);
#define BEtoU32(x) U32toBE(x)
#define BEtoS32(x) S32toBE(x)
#define BEtoU16(x) U16toBE(x)
#define BEtoS16(x) S16toBE(x)

u_int32 U32toLE(u_int32);
s_int32 S32toLE(s_int32);
u_int16 U16toLE(u_int16 n);
s_int16 S16toLE(s_int16 n);
#define LEtoU32(x) U32toLE(x)
#define LEtoS32(x) S32toLE(x)
#define LEtoU16(x) U16toLE(x)
#define LEtoS16(x) S16toLE(x)



void FLT64toBE(flt64 *x);
void FLT32toBE(flt32 *x);
#define BEtoFLT64(x) FLT64toBE(x)
#define BEtoFLT32(x) FLT32toBE(x)

void FLT64toLE(flt64 *x);
void FLT32toLE(flt32 *x);
#define LEtoFLT64(x) FLT64toLE(x)
#define LEtoFLT32(x) FLT32toLE(x)

#endif
